#version 120
#extension GL_EXT_gpu_shader3 : enable

uniform float pointSize;

uniform vec4 viewport;
uniform int fogMode;
uniform int dissolveMode;

uniform vec2 ensembleParamA;
uniform float ensembleParamB;
uniform vec2 ensembleParamC;

uniform float projInv11;
uniform float projInv15;

varying vec4 position;
varying vec2 center;
varying vec2 relCenter;
varying float cosPhi;
varying float sinPhi;
varying float coscosPhi;
varying float sinsinPhi;
varying float sincosPhi;
varying float radius2;
varying float B2;//radiusFactor2;

//##FUNC_SMOOTHCLIPPING##

//##FUNC_FOG_EFFECT##

void main (void)
{
    //if ( distance( gl_FragCoord.xy, center ) >= radius ) discard;
    if (radius2 == 0) discard;

    float dx = gl_FragCoord.x - center.x;
    float dy = gl_FragCoord.y - center.y;

    //float B2 = radiusFactor2;

    if ((dx*dx*(B2*coscosPhi + sinsinPhi)
	 + 2 * dx*dy * sincosPhi * (B2 - 1) 
	 + dy*dy*(B2*sinsinPhi + coscosPhi)) >= B2 * radius2)
	discard;
	
    float alpha = gl_Color[3];

    //##APPLY_SMOOTHCLIPPING##
    
    if (dissolveMode == 1 || dissolveMode == 2){
	float bound = 0.015;
	if (dissolveMode >= 2) bound = 1;
	
	if (alpha <= bound){
	    float crit = fract(sin(dot(gl_FragCoord.xy + position.xz + ensembleParamA ,
				       /*vec2(12.9898,78.233)*/ensembleParamC)) * ensembleParamB) * bound;
	    if (alpha <= crit) discard;
	    else alpha = bound;
	}
    } else if (dissolveMode == 3){
	float bound = 1;
	
	if (alpha <= bound){
	    float crit = fract(sin(dot(center + position.xz + ensembleParamA ,
				       /*vec2(12.9898,78.233))*/ensembleParamC)) * ensembleParamB) * bound;
	    if (alpha <= crit) discard;
	    else alpha = bound;
	}
    }

    if (alpha > 1.0) alpha = 1.0;
    
    gl_FragColor = gl_Color;//color;

    //##APPLY_FOG_EFFECT##

    gl_FragColor[3] = alpha;
}
