// PointSprite.geom

// SetParameter GL_GEOMETRY_INPUT_TYPE_EXT=GL_TRIANGLES_ADJACENCY_EXT
// SetParameter GL_GEOMETRY_OUTPUT_TYPE_EXT=GL_TRIANGLES
// SetParameter GL_GEOMETRY_VERTICES_OUT_EXT=24

#version 120
#extension GL_EXT_geometry_shader4 : enable
#extension GL_EXT_gpu_shader4 : enable

uniform float shadowLength;

varying in vec3 positionIn[];
varying in vec4 colorIn[];

//varying in float pointSizeIn[];
varying out vec4 color;

void main(void){

    vec3 lightVec = gl_LightSource[0].position.xyz - positionIn[0] * gl_LightSource[0].position[3];
    vec3 nlightVec = -normalize(lightVec);
    
    vec3 polyNormal = cross(vec3(positionIn[2] - positionIn[0]), vec3(positionIn[4] - positionIn[0]));
    float litOrNot = dot(lightVec, polyNormal);
    
    if (litOrNot <= 0) return;
    
    vec3 polyNormalABdash = cross(vec3(positionIn[1] - positionIn[0]), vec3(positionIn[2] - positionIn[0]));
    float litOrNotABdash = dot(lightVec, polyNormalABdash);

    vec3 polyNormalBCdash = cross(vec3(positionIn[3] - positionIn[2]), vec3(positionIn[4] - positionIn[2]));
    float litOrNotBCdash = dot(lightVec, polyNormalBCdash);

    vec3 polyNormalCAdash = cross(vec3(positionIn[5] - positionIn[4]), vec3(positionIn[0] - positionIn[4]));
    float litOrNotCAdash = dot(lightVec, polyNormalCAdash);

    vec3 offsetS = nlightVec * shadowLength * 0.001;
    vec3 offsetL = nlightVec * shadowLength;

    color = colorIn[0];

    /*
    gl_Position = gl_PositionIn[0];
    color = colorIn[0];
    EmitVertex();
    gl_Position = gl_PositionIn[1];
    color = colorIn[1];
    EmitVertex();
    gl_Position = gl_PositionIn[2];
    color = colorIn[2];
    EmitVertex();
    EndPrimitive();
    */
    
    gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetS, 1);
    EmitVertex();
    gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetS, 1);
    EmitVertex();
    gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetS, 1);
    EmitVertex();
    EndPrimitive();

    if (litOrNotABdash < 0){
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetS, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetL, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetS, 1);
	EmitVertex();
	EndPrimitive();
	
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetS, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetL, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetL, 1);
	EmitVertex();
	EndPrimitive();
    }

    if (litOrNotBCdash < 0){
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetS, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetL, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetS, 1);
	EmitVertex();
	EndPrimitive();

	gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetS, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetL, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetL, 1);
	EmitVertex();
	EndPrimitive();
    }

    if (litOrNotCAdash < 0){
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetS, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetL, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetS, 1);
	EmitVertex();
	EndPrimitive();
	
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetS, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetL, 1);
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetL, 1);
	EmitVertex();
	EndPrimitive();
    }

    gl_Position = gl_ProjectionMatrix * vec4(positionIn[0] + offsetL, 1);
    EmitVertex();
    gl_Position = gl_ProjectionMatrix * vec4(positionIn[4] + offsetL, 1);
    EmitVertex();
    gl_Position = gl_ProjectionMatrix * vec4(positionIn[2] + offsetL, 1);
    EmitVertex();
    EndPrimitive();
    
    /*
    vec4 nX = gl_ModelViewProjectionMatrix * vec4(1, 0, 0, 0);
    vec4 nY = gl_ModelViewProjectionMatrix * vec4(0, 1, 0, 0);
    vec4 nZ = gl_ModelViewProjectionMatrix * vec4(0, 0, 1, 0);

    float psize = pointSizeIn[0];
    int flip = 0;
    if (psize < 0){
	flip = 1;
	psize *= -1;
    }

    nX *= psize;
    nY *= psize;
    nZ *= psize;

    int current = 0;
    int itemCount = 0;
    while (true){
	int index = indexList[current];
	if (index == -1){
	    if (itemCount != 0){
		EndPrimitive();
		itemCount = 0;
	    }
	}
	else {
	    gl_Position = gl_PositionIn[0] + nX * vertex[index].x + nY * vertex[index].y + nZ * vertex[index].z;
	    EmitVertex();
	    if (flip == 1 && itemCount == 0) EmitVertex();
	    itemCount++;
	}
	    
	current ++;
	if (current >= indexListSize) break;
    }
    */
}
